Completions
Create completion
Completion completions().create(CompletionCreateParamsparams, RequestOptionsrequestOptions = RequestOptions.none())
post /completions
Creates a completion for the provided prompt and parameters.
Returns a completion object, or a sequence of completion objects if the request is streamed.
Parameters
-
CompletionCreateParams params-
Model modelID of the model to use. You can use the List models API to see all of your available models, or see our Model overview for descriptions of them.
-
GPT_3_5_TURBO_INSTRUCT("gpt-3.5-turbo-instruct") -
DAVINCI_002("davinci-002") -
BABBAGE_002("babbage-002")
-
-
Optional<Prompt> promptThe prompt(s) to generate completions for, encoded as a string, array of strings, array of tokens, or array of token arrays.
Note that <|endoftext|> is the document separator that the model sees during training, so if a prompt is not specified the model will generate as if from the beginning of a new document.
-
String -
List<String> -
List<long> -
List<List<long>>
-
-
Optional<Long> bestOfGenerates
best_ofcompletions server-side and returns the "best" (the one with the highest log probability per token). Results cannot be streamed.When used with
n,best_ofcontrols the number of candidate completions andnspecifies how many to return –best_ofmust be greater thann.Note: Because this parameter generates many completions, it can quickly consume your token quota. Use carefully and ensure that you have reasonable settings for
max_tokensandstop. -
Optional<Boolean> echoEcho back the prompt in addition to the completion
-
Optional<Double> frequencyPenaltyNumber between -2.0 and 2.0. Positive values penalize new tokens based on their existing frequency in the text so far, decreasing the model's likelihood to repeat the same line verbatim.
See more information about frequency and presence penalties.
-
Optional<LogitBias> logitBiasModify the likelihood of specified tokens appearing in the completion.
Accepts a JSON object that maps tokens (specified by their token ID in the GPT tokenizer) to an associated bias value from -100 to 100. You can use this tokenizer tool to convert text to token IDs. Mathematically, the bias is added to the logits generated by the model prior to sampling. The exact effect will vary per model, but values between -1 and 1 should decrease or increase likelihood of selection; values like -100 or 100 should result in a ban or exclusive selection of the relevant token.
As an example, you can pass
{"50256": -100}to prevent the <|endoftext|> token from being generated. -
Optional<Long> logprobsInclude the log probabilities on the
logprobsmost likely output tokens, as well the chosen tokens. For example, iflogprobsis 5, the API will return a list of the 5 most likely tokens. The API will always return thelogprobof the sampled token, so there may be up tologprobs+1elements in the response.The maximum value for
logprobsis 5. -
Optional<Long> maxTokensThe maximum number of tokens that can be generated in the completion.
The token count of your prompt plus
max_tokenscannot exceed the model's context length. Example Python code for counting tokens. -
Optional<Long> nHow many completions to generate for each prompt.
Note: Because this parameter generates many completions, it can quickly consume your token quota. Use carefully and ensure that you have reasonable settings for
max_tokensandstop. -
Optional<Double> presencePenaltyNumber between -2.0 and 2.0. Positive values penalize new tokens based on whether they appear in the text so far, increasing the model's likelihood to talk about new topics.
See more information about frequency and presence penalties.
-
Optional<Long> seedIf specified, our system will make a best effort to sample deterministically, such that repeated requests with the same
seedand parameters should return the same result.Determinism is not guaranteed, and you should refer to the
system_fingerprintresponse parameter to monitor changes in the backend. -
Optional<Stop> stopNot supported with latest reasoning models
o3ando4-mini.Up to 4 sequences where the API will stop generating further tokens. The returned text will not contain the stop sequence.
-
String -
List<String>
-
-
Optional<ChatCompletionStreamOptions> streamOptionsOptions for streaming response. Only set this when you set
stream: true. -
Optional<String> suffixThe suffix that comes after a completion of inserted text.
This parameter is only supported for
gpt-3.5-turbo-instruct. -
Optional<Double> temperatureWhat sampling temperature to use, between 0 and 2. Higher values like 0.8 will make the output more random, while lower values like 0.2 will make it more focused and deterministic.
We generally recommend altering this or
top_pbut not both. -
Optional<Double> topPAn alternative to sampling with temperature, called nucleus sampling, where the model considers the results of the tokens with top_p probability mass. So 0.1 means only the tokens comprising the top 10% probability mass are considered.
We generally recommend altering this or
temperaturebut not both. -
Optional<String> userA unique identifier representing your end-user, which can help OpenAI to monitor and detect abuse. Learn more.
-
Returns
-
class Completion:Represents a completion response from the API. Note: both the streamed and non-streamed response objects share the same shape (unlike the chat endpoint).
-
String idA unique identifier for the completion.
-
List<CompletionChoice> choicesThe list of completion choices the model generated for the input prompt.
-
FinishReason finishReasonThe reason the model stopped generating tokens. This will be
stopif the model hit a natural stop point or a provided stop sequence,lengthif the maximum number of tokens specified in the request was reached, orcontent_filterif content was omitted due to a flag from our content filters.-
STOP("stop") -
LENGTH("length") -
CONTENT_FILTER("content_filter")
-
-
long index -
Optional<Logprobs> logprobs-
Optional<List<Long>> textOffset -
Optional<List<Double>> tokenLogprobs -
Optional<List<String>> tokens -
Optional<List<TopLogprob>> topLogprobs
-
-
String text
-
-
long createdThe Unix timestamp (in seconds) of when the completion was created.
-
String modelThe model used for completion.
-
JsonValue; object_ "text_completion"constantThe object type, which is always "text_completion"
TEXT_COMPLETION("text_completion")
-
Optional<String> systemFingerprintThis fingerprint represents the backend configuration that the model runs with.
Can be used in conjunction with the
seedrequest parameter to understand when backend changes have been made that might impact determinism. -
Optional<CompletionUsage> usageUsage statistics for the completion request.
-
long completionTokensNumber of tokens in the generated completion.
-
long promptTokensNumber of tokens in the prompt.
-
long totalTokensTotal number of tokens used in the request (prompt + completion).
-
Optional<CompletionTokensDetails> completionTokensDetailsBreakdown of tokens used in a completion.
-
Optional<Long> acceptedPredictionTokensWhen using Predicted Outputs, the number of tokens in the prediction that appeared in the completion.
-
Optional<Long> audioTokensAudio input tokens generated by the model.
-
Optional<Long> reasoningTokensTokens generated by the model for reasoning.
-
Optional<Long> rejectedPredictionTokensWhen using Predicted Outputs, the number of tokens in the prediction that did not appear in the completion. However, like reasoning tokens, these tokens are still counted in the total completion tokens for purposes of billing, output, and context window limits.
-
-
Optional<PromptTokensDetails> promptTokensDetailsBreakdown of tokens used in the prompt.
-
Optional<Long> audioTokensAudio input tokens present in the prompt.
-
Optional<Long> cacheWriteTokensThe unadjusted number of prompt tokens written to cache.
-
Optional<Long> cachedTokensCached tokens present in the prompt.
-
-
-
Example
package com.openai.example;
import com.openai.client.OpenAIClient;
import com.openai.client.okhttp.OpenAIOkHttpClient;
import com.openai.models.completions.Completion;
import com.openai.models.completions.CompletionCreateParams;
public final class Main {
private Main() {}
public static void main(String[] args) {
OpenAIClient client = OpenAIOkHttpClient.fromEnv();
CompletionCreateParams params = CompletionCreateParams.builder()
.model(CompletionCreateParams.Model.GPT_3_5_TURBO_INSTRUCT)
.prompt("This is a test.")
.build();
Completion completion = client.completions().create(params);
}
}
Response
{
"id": "id",
"choices": [
{
"finish_reason": "stop",
"index": 0,
"logprobs": {
"text_offset": [
0
],
"token_logprobs": [
0
],
"tokens": [
"string"
],
"top_logprobs": [
{
"foo": 0
}
]
},
"text": "text"
}
],
"created": 0,
"model": "model",
"object": "text_completion",
"system_fingerprint": "system_fingerprint",
"usage": {
"completion_tokens": 0,
"prompt_tokens": 0,
"total_tokens": 0,
"completion_tokens_details": {
"accepted_prediction_tokens": 0,
"audio_tokens": 0,
"reasoning_tokens": 0,
"rejected_prediction_tokens": 0
},
"prompt_tokens_details": {
"audio_tokens": 0,
"cache_write_tokens": 0,
"cached_tokens": 0
}
}
}
Domain Types
Completion
-
class Completion:Represents a completion response from the API. Note: both the streamed and non-streamed response objects share the same shape (unlike the chat endpoint).
-
String idA unique identifier for the completion.
-
List<CompletionChoice> choicesThe list of completion choices the model generated for the input prompt.
-
FinishReason finishReasonThe reason the model stopped generating tokens. This will be
stopif the model hit a natural stop point or a provided stop sequence,lengthif the maximum number of tokens specified in the request was reached, orcontent_filterif content was omitted due to a flag from our content filters.-
STOP("stop") -
LENGTH("length") -
CONTENT_FILTER("content_filter")
-
-
long index -
Optional<Logprobs> logprobs-
Optional<List<Long>> textOffset -
Optional<List<Double>> tokenLogprobs -
Optional<List<String>> tokens -
Optional<List<TopLogprob>> topLogprobs
-
-
String text
-
-
long createdThe Unix timestamp (in seconds) of when the completion was created.
-
String modelThe model used for completion.
-
JsonValue; object_ "text_completion"constantThe object type, which is always "text_completion"
TEXT_COMPLETION("text_completion")
-
Optional<String> systemFingerprintThis fingerprint represents the backend configuration that the model runs with.
Can be used in conjunction with the
seedrequest parameter to understand when backend changes have been made that might impact determinism. -
Optional<CompletionUsage> usageUsage statistics for the completion request.
-
long completionTokensNumber of tokens in the generated completion.
-
long promptTokensNumber of tokens in the prompt.
-
long totalTokensTotal number of tokens used in the request (prompt + completion).
-
Optional<CompletionTokensDetails> completionTokensDetailsBreakdown of tokens used in a completion.
-
Optional<Long> acceptedPredictionTokensWhen using Predicted Outputs, the number of tokens in the prediction that appeared in the completion.
-
Optional<Long> audioTokensAudio input tokens generated by the model.
-
Optional<Long> reasoningTokensTokens generated by the model for reasoning.
-
Optional<Long> rejectedPredictionTokensWhen using Predicted Outputs, the number of tokens in the prediction that did not appear in the completion. However, like reasoning tokens, these tokens are still counted in the total completion tokens for purposes of billing, output, and context window limits.
-
-
Optional<PromptTokensDetails> promptTokensDetailsBreakdown of tokens used in the prompt.
-
Optional<Long> audioTokensAudio input tokens present in the prompt.
-
Optional<Long> cacheWriteTokensThe unadjusted number of prompt tokens written to cache.
-
Optional<Long> cachedTokensCached tokens present in the prompt.
-
-
-
Completion Choice
-
class CompletionChoice:-
FinishReason finishReasonThe reason the model stopped generating tokens. This will be
stopif the model hit a natural stop point or a provided stop sequence,lengthif the maximum number of tokens specified in the request was reached, orcontent_filterif content was omitted due to a flag from our content filters.-
STOP("stop") -
LENGTH("length") -
CONTENT_FILTER("content_filter")
-
-
long index -
Optional<Logprobs> logprobs-
Optional<List<Long>> textOffset -
Optional<List<Double>> tokenLogprobs -
Optional<List<String>> tokens -
Optional<List<TopLogprob>> topLogprobs
-
-
String text
-
Completion Usage
-
class CompletionUsage:Usage statistics for the completion request.
-
long completionTokensNumber of tokens in the generated completion.
-
long promptTokensNumber of tokens in the prompt.
-
long totalTokensTotal number of tokens used in the request (prompt + completion).
-
Optional<CompletionTokensDetails> completionTokensDetailsBreakdown of tokens used in a completion.
-
Optional<Long> acceptedPredictionTokensWhen using Predicted Outputs, the number of tokens in the prediction that appeared in the completion.
-
Optional<Long> audioTokensAudio input tokens generated by the model.
-
Optional<Long> reasoningTokensTokens generated by the model for reasoning.
-
Optional<Long> rejectedPredictionTokensWhen using Predicted Outputs, the number of tokens in the prediction that did not appear in the completion. However, like reasoning tokens, these tokens are still counted in the total completion tokens for purposes of billing, output, and context window limits.
-
-
Optional<PromptTokensDetails> promptTokensDetailsBreakdown of tokens used in the prompt.
-
Optional<Long> audioTokensAudio input tokens present in the prompt.
-
Optional<Long> cacheWriteTokensThe unadjusted number of prompt tokens written to cache.
-
Optional<Long> cachedTokensCached tokens present in the prompt.
-
-